libzypp: zypp::base::SetRelationMixin< Derived > Class Template Reference

libzypp 17.38.6

zypp::base::SetRelationMixin< Derived > Class Template Reference
CRTP solutions

Provide set relation methods based on Derived::setRelationMixinCompare A class using this mixin must provide: More...

`#include <zypp/base/SetRelationMixin.h>`

## Public Member Functions
SetCompare | compare (const Derived &trg) const
| Compare sets.
SetCompare | compare (const SetRelationMixin< Derived > &trg) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | compare (const Derived &trg, SetCompare cmp) const
| Compare sets and match against SetCompare.
bool | compare (const SetRelationMixin< Derived > &trg, SetCompare cmp) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | compare (const Derived &trg, SetRelation rel) const
| Compare sets and match against SetRelation.
bool | compare (const SetRelationMixin< Derived > &trg, SetRelation rel) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## Protected Member Functions
| SetRelationMixin ()
| DEFAULT_COPYABLE (SetRelationMixin)
| DEFAULT_MOVABLE (SetRelationMixin)
| ~SetRelationMixin ()

## Private Member Functions
const Derived & | derived () const
| Access to sublass Derived.

## Detailed Description

template<class Derived>
class zypp::base::SetRelationMixin< Derived >

Provide set relation methods based on Derived::setRelationMixinCompare A class using this mixin must provide:

SetCompare setRelationMixinCompare( const Derived & rhs ) const;
zypp::SetCompare
base::EnumClass< ESetCompareDef > SetCompare
relates: ESetCompareDef typedef 'enum class SetCompare'
Definition SetRelationMixin.h:40

See also
  SETRELATIONMIXIN_DEFINE_COMPARE_BETWEEN

Definition at line 144 of file SetRelationMixin.h.

## Constructor & Destructor Documentation

## ◆ SetRelationMixin()

template<class Derived>

zypp::base::SetRelationMixin< Derived >::SetRelationMixin | ( |  | ) |
| inlineprotected

Definition at line 169 of file SetRelationMixin.h.

## ◆ ~SetRelationMixin()

template<class Derived>

zypp::base::SetRelationMixin< Derived >::~SetRelationMixin | ( |  | ) |
| inlineprotected

Definition at line 172 of file SetRelationMixin.h.

## Member Function Documentation

## ◆ compare() [1/6]

template<class Derived>

SetCompare zypp::base::SetRelationMixin< Derived >::compare | ( | const Derived & | trg | ) | const
| inline

Compare sets.

Definition at line 148 of file SetRelationMixin.h.

## ◆ compare() [2/6]

template<class Derived>

SetCompare zypp::base::SetRelationMixin< Derived >::compare | ( | const SetRelationMixin< Derived > & | trg | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 151 of file SetRelationMixin.h.

## ◆ compare() [3/6]

template<class Derived>

bool zypp::base::SetRelationMixin< Derived >::compare | ( | const Derived & | trg,
|  | SetCompare | cmp ) const
| inline

Compare sets and match against SetCompare.

Definition at line 155 of file SetRelationMixin.h.

## ◆ compare() [4/6]

template<class Derived>

bool zypp::base::SetRelationMixin< Derived >::compare | ( | const SetRelationMixin< Derived > & | trg,
|  | SetCompare | cmp ) const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 158 of file SetRelationMixin.h.

## ◆ compare() [5/6]

template<class Derived>

bool zypp::base::SetRelationMixin< Derived >::compare | ( | const Derived & | trg,
|  | SetRelation | rel ) const
| inline

Compare sets and match against SetRelation.

Definition at line 162 of file SetRelationMixin.h.

## ◆ compare() [6/6]

template<class Derived>

bool zypp::base::SetRelationMixin< Derived >::compare | ( | const SetRelationMixin< Derived > & | trg,
|  | SetRelation | rel ) const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 165 of file SetRelationMixin.h.

## ◆ DEFAULT_COPYABLE()

template<class Derived>

zypp::base::SetRelationMixin< Derived >::DEFAULT_COPYABLE | ( | SetRelationMixin< Derived > |  | ) |
| protected

## ◆ DEFAULT_MOVABLE()

template<class Derived>

zypp::base::SetRelationMixin< Derived >::DEFAULT_MOVABLE | ( | SetRelationMixin< Derived > |  | ) |
| protected

## ◆ derived()

template<class Derived>

const Derived & zypp::base::SetRelationMixin< Derived >::derived | ( |  | ) | const
| inlineprivate

Access to sublass Derived.

Definition at line 176 of file SetRelationMixin.h.

The documentation for this class was generated from the following file:

- zypp/base/SetRelationMixin.h